import 'package:firebase_auth/firebase_auth.dart';

import 'user_meta_data.dart';

class AuthUser {
  final String id;
  final String displayName;
  final String email;
  final bool emailVerified;
  final bool isAnonymous;
  final UserMetaData metaData;
  final String? phoneNumber;
  final String? photoURL;
  List<UserInfo> providerData;
  String? refreshToken;
  final Future<void> Function(String name) updateDisplayName;
  final Future<void> Function() sendVerificationEmail;
  final Future<void> Function() reload;
  final Future<String?> Function([bool forceRefresh]) getIdToken;

  AuthUser(
    this.id, {
    required this.displayName,
    required this.email,
    required this.emailVerified,
    required this.isAnonymous,
    required this.metaData,
    required this.phoneNumber,
    required this.photoURL,
    required this.providerData,
    required this.refreshToken,
    required this.updateDisplayName,
    required this.sendVerificationEmail,
    required this.reload,
    required this.getIdToken,
  });

  @override
  String toString() {
    return 'AuthUser{id: $id, displayName: $displayName, email: $email, emailVerified: $emailVerified, isAnonymous: $isAnonymous, metadata: $metaData, phoneNumber: $phoneNumber, photoURL: $photoURL, providerData: $providerData, refreshToken: $refreshToken}';
  }
}
